package ovh.herisson.thevoidroad.Entity;

import java.io.File;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.Random;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.NamespacedKey;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.entity.Villager;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryAction;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryInteractEvent;
import org.bukkit.event.player.PlayerInteractEntityEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.world.EntitiesLoadEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.persistence.PersistentDataType;

import net.kyori.adventure.text.Component;
import ovh.herisson.thevoidroad.DatabaseManager;
import ovh.herisson.thevoidroad.TheVoidRoad;
import ovh.herisson.thevoidroad.Voids;
import ovh.herisson.thevoidroad.Event.HourEvent;
import ovh.herisson.thevoidroad.util.Tuple;

//Unique, so singleton patern
public class Merchand implements Listener{
	public static Tuple<Material, Integer> current, next;
	private static Merchand instance;
	private static final ArrayList<Material> mat = new ArrayList<>();
	private final Inventory inv;
	private Villager m ;

	private static final NamespacedKey tagger = new NamespacedKey(TheVoidRoad.instance, "merchand") ;

	public static Merchand getInstance(){
		if(instance == null)
			instance = new Merchand();
		return instance;
	}

	private Merchand() {
		inv = Bukkit.createInventory(null, 9);
		File f = new File(TheVoidRoad.instance.getDataFolder(), "materials.txt");
		try {
			for (String s :	Files.readAllLines(f.toPath())) {
				mat.add(Material.valueOf(s));
			}
		} catch(Exception e){
			e.printStackTrace();
		}
		if(DatabaseManager.getInstance().getConfig("init") != null &&
				DatabaseManager.getInstance().getConfig("init").equalsIgnoreCase("true")){
			regenerate();
		}
	}

	public void regenerate(){
		if(m != null){ m.remove(); }
		current = genTrade(System.currentTimeMillis() / (1000 * 60 * 60));
		Location center = Bukkit.getWorld("world").getWorldBorder().getCenter();
		double brdSize = Bukkit.getWorld("world").getWorldBorder().getSize();
		double x = new Random().nextDouble(brdSize) - brdSize/2, z = new Random().nextDouble(brdSize) - brdSize/2;
		m = (Villager) Bukkit.getWorld("world").spawnEntity(center.add(x, 100, z), EntityType.VILLAGER);
		m.getPersistentDataContainer().set(tagger, PersistentDataType.BOOLEAN, true);
		m.setGlowing(true);
		m.setInvulnerable(true);
		Bukkit.getServer().forEachAudience((a) -> {
			if(a instanceof Player ply){
				ply.setCompassTarget(m.getLocation());
			}
		}); //Temporary
		Bukkit.getServer().sendMessage(Component.text("The merchand just spawned"));
	}

	public Location getLocation(){
		return m != null ? m.getLocation(): null;
	}

	public static Tuple<Material, Integer> genTrade(long hour){
		Random rnd = new Random(hour);
		return new Tuple<>(mat.get(rnd.nextInt(mat.size())), rnd.nextInt(9)+1);
	}

	@EventHandler
	public void checkTagged(EntitiesLoadEvent e){
		for (Entity m : e.getEntities()) {
			if(m.getPersistentDataContainer().has(tagger) && m.getPersistentDataContainer().get(tagger, PersistentDataType.BOOLEAN)){
				if(!m.equals(this.m)){
					m.remove();
				}
			}
		}
	}

	@EventHandler
	public void onHour(HourEvent e){
		current = genTrade(e.unixhour);
		next = genTrade(e.unixhour + 1);
		regenerate();
	}

	@EventHandler
	public void OpenInventory(PlayerInteractEntityEvent e){
		if(e.getRightClicked().equals(m)){
			e.setCancelled(true);
			inv.clear();
			inv.setItem(4, new ItemStack(current.x, current.y));
			e.getPlayer().openInventory(inv);
		}
	}

	@EventHandler
	public void Compass(PlayerInteractEvent e){
		if(getLocation() != null && e.getItem() != null && e.getItem().getType() == Material.COMPASS){
			e.getPlayer().setCompassTarget(getLocation());
		}
	}

	//Inventory interaction
	@EventHandler
	public void ClickInsideInventory(InventoryClickEvent e){
		// Did the click the right slot in the right inventory
		if(!e.getInventory().equals(inv)) return;
		e.setCancelled(true);
		if(!e.getInventory().equals(inv) || e.getSlot() != 4) return;

		if(e.getWhoClicked() instanceof Player ply){
			//Do we have the item and if so remove them
			if(ply.getInventory().contains(current.x)){
				for (ItemStack i : ply.getInventory().getContents()) {
					if(i.getType() == current.x){
						i.subtract(1);
						Voids.add(ply, current.y);
						return;
					}
				}
			}
		}
	}
}
